Download presentation
Published byIsabel Price Modified over 9 years ago
1
Zero to 3D in 60 Minutes Fenton Webb Senior Developer Evangelist
2
About the Presenter Fenton Webb Developer Technical Services Americas Autodesk, Inc Fenton has been a member of the Autodesk DevTech team since Originally a member of our EMEA team, he has recently relocated to California to work for DevTech Americas. Fenton is an expert in all the AutoCAD APIs, AutoCAD OEM, RealDWG and Revit. He particularly enjoys travelling to evangelise the APIs he support at our annual Developer Days conferences. Before joining Autodesk, Fenton worked for an ADN partner developing ObjectARX applications in the Civil and Structural Engineering domain.
3
Autodesk Developer Network
Access to almost all Autodesk software and SDK’s Including early access to Beta software Members-only website with 1000s of technical articles Unlimited technical support Product direction through conferences Marketing benefits Exposure on autodesk.com Promotional opportunities 1 to 3 free API training classes Based on user level Some of you may be unfamiliar with ADN. The Autodesk Developer Network is a program providing professional support to programmers writing addin applications for Autodesk software. If you think the program benefits listed here would be useful to you, then visit this URL and read more about it. You don’t have to be a commercial software developer to join ADN.
4
DevLab San Francisco, USA Feb 1-5, 2010 Farnborough, UK Feb 8-12, 2010
Munich, Germany June 7-11, 2010 Other countries TBD > Schedule The one resource I do want to mention is DevLab. If you need help and advice with your AutoCAD addin development, you might like to come to one of our free DevLab events. DevLab isn’t a training class – it’s a workshop. Bring along your laptop and work on your application development as normal, but you have a team of DevTech engineers in the room with you ready to answer your questions. If you’re struggling with a tricky bug or implementation issue, or if you just need some advice on your application design, then come along to DevLab and talk to us. You don’t have to be an ADN member to take part. Visit our training page now to sign up, or me for more information. And all that remains for me now is to say thank you for listening. And good luck with your .NET programming. You’re welcome to continue to ask questions using the online console until this session times out or to me later.
5
Agenda History of 3D in AutoCAD Creating 3D Geometry
Creating Advanced 3D Geometry Logical - Unions, Subtracts and Intersect Geometrical - Extrusions, Lofts, Revolves and Sweeps Freeform Modeling Extract the 3D Data Questions
6
History of 3D in AutoCAD Version 2.1
Technology Information Version 2.1 Z Coordinate R11 AutoCAD Modeling Extension (AME) ADS API R13 ACIS - Licensed Technology from Spatial Industry Standard SAT Output 2004 ASM – Autodesk Solid Modeler Derived from ACIS Autodesk Standard Amodeler – Autodesk Modeler Focused Surface Modeler used by ADT/AutoCAD Architecture
7
Creating 3D Geometry Easy to Create Basic 3D Geometry – Solid Types
Using AutoCAD Easy to Create Basic 3D Geometry – Solid Types Known as Primitive Solids Commands Box, Wedge, Cone, Cylinder, Sphere, Pyramid, Torus See AutoCAD Help Create 3D Solid Primitives
8
Creating 3D Geometry You can easily modify Primitive Solids
Using AutoCAD You can easily modify Primitive Solids Via the Properties Window Via Grips Basic Properties Keeps Shape
9
Creating 3D Geometry Advanced modification is possible
Using AutoCAD Advanced modification is possible Sub-Object Selection (CTRL+Left Click) Faces Edges Vertices
10
Creating 3D Geometry .NET Solid3d.Create*
Using APIs .NET Solid3d.Create* CreateBox, CreateSphere, CreateTorus, etc ObjectARX AcDb3dSolid::create* createBox, CreateSphere, CreateTorus , etc VBA or Visual LISP Active X Acad3dSolid.Add* AddBox, AddSphere, AddTorus, etc LISP Command Line method ActiveX LISP (using the same API as VBA)
11
Creating 3D Geometry Demo Demonstrating Show how... “Basic 3D”
Visual Studio 2008 Using Solid3d class Using C# .NET
12
Creating Advanced 3D Geometry
Using Logical Operations Synthesizing Solids Union Subtract Intersect
13
Creating Advanced 3D Geometry
Using Logical Operations Synthesizing Solids Union Combine
14
Creating Advanced 3D Geometry
Using Logical Operations Synthesizing Solids Subtract
15
Creating Advanced 3D Geometry
Using Logical Operations Synthesizing Solids Intersect Common
16
Logical Solid3D Operations
Creating 3D Geometry Show how... Demo “Logical 3D” Demonstrating Logical Solid3D Operations Union Subtract Intersect Using C# .NET
17
Creating Advanced 3D Geometry
Using AutoCAD Extrude, Loft, Revolve and Sweep - Surface (and Solid) Types
18
Creating Advanced 3D Geometry
Using AutoCAD You can modify these types Via the Properties Window Via Grips Construction Geometry Only
19
Creating Advanced 3D Geometry
Using AutoCAD Advanced modification not possible Sub-Object Selection (CTRL+Left Click) Faces Edges Vertices
20
Creating Advanced 3D Geometry
Using APIs .NET Extrude SweepOptions / SweepOptionsBuilder ExtrudedSurface.CreateExtrudedSurface Sweep SweptSurface.CreateSweptSurface Loft LoftOptions / LoftOptionsBuilder Solid3d.CreateLoftedSolid Revolve RevolveOptions / RevolveOptionsBuilder Solid3d.CreateRevolvedSolid Surface Type Surface Type Solid Type Solid Type
21
Creating Advanced 3D Geometry
Using APIs ObjectARX Extrude AcDbSweepOptions AcDbExtrudedSurface::createExtrudedSurface Sweep AcDbSweptSurface::createSweptSurface Loft AcDbLoftOptions AcDb3dSolid::createLoftedSolid Revolve AcDbRevolveOptions AcDb3dSolid::createRevolvedSolid Surface Type Surface Type Solid Type Solid Type
22
Creating Advanced 3D Geometry
Using APIs VBA or Visual LISP ActiveX Extrude AddExtrudedSolid Sweep SweptSurface – Read Only Loft LoftedSurface – Read Only Revolve AddRevolvedSolid Surface Type Surface Type Solid Type Solid Type
23
Creating Advanced 3D Geometry
Show how... Demo “Advanced 3D” Demonstrating Extrudes Lofts Sweeps Revolves Using C# .NET
24
Freeform Modeling New features Required Unique Style of Modeling
Realisations New features Required Unique Style of Modeling Takes 3D Modeling to the next level! Quicker and easier Special Gadgets ASM Solids Are Very Powerful Great at Everything What about DWG compatibility? Face limitation (32k)
25
Freeform Modeling New SubDMesh entity Uses Catmull-Clark algorithm
New API New SubDMesh entity Uses Catmull-Clark algorithm Edge and surface creasing No 32k face limit API Available in ObjectARX – AcDbSubDMesh .NET - SubDMesh
26
Freeform Modeling What is SubD A subdivision surface is a smooth surface created from a coarse mesh. The smooth surface is calculated by iteratively subdividing each polygonal face into smaller faces that better approximate the smooth surface. See
27
Freeform Modeling Demo Demonstrating Show how... “Freeform Modeling”
Freeform Modeling SDK Sample Create from primitive Create from ASM solid Applying creases Transform mesh elements Convert to ASM solid Using VB.NET
28
Boundary Representation Brep ObjectARX and .NET
Extract the 3D Data Introducing Brep Boundary Representation Brep ObjectARX and .NET Solids Regions Bodies Surfaces* Represents shapes using Limits Limits defined using hierarchically connected objects Otherwise known as Topology
29
Extract the 3D Data Boundaries gives Faces, Faces gives Edges
How Brep works Boundaries gives Faces, Faces gives Edges Geometric information are associated with three basic entities ( Surfacesfaces, Curvesedges, PointsVertices )
30
Extracting 3D Data from a Solid
Extract the 3D Data Show how... Demo “Brep” Demonstrating Visual Studio 2008 Extracting 3D Data from a Solid Using C# .NET
31
Zero to 3D SDK and Samples Developer Center Discussion Groups
Further reading... SDK and Samples Developer Center Discussion Groups API Training Classes Kean’s Through the Interface Blog Autodesk Developer Network
32
Thank you – Any questions?
Zero to 3D in 60 Minutes Fenton Webb Senior Developer Evangelist
Similar presentations
© 2025 SlidePlayer.com. Inc.
All rights reserved.